open Typage;;

(* La grille *)
let grille1 =
  let init_grille g = (
    g.(0) <- Array.mapi (fun i b -> true) g.(0);
    g.(1) <- Array.mapi (fun i b -> match i with 0|9 -> true | _ -> false) g.(1);
    g.(2) <- Array.mapi (fun i b -> match i with 0|9 -> true | _ -> false) g.(2);
    g.(3) <- Array.mapi (fun i b -> match i with 0|9 -> true | _ -> false) g.(3);
    g.(4) <- Array.mapi (fun i b -> match i with 0|7|8|9 -> true | _ -> false) g.(4);
    g.(5) <- Array.mapi (fun i b -> match i with 0|7|8|9 -> true | _ -> false) g.(5);
    g.(6) <- Array.mapi (fun i b -> match i with 0|9 -> true | _ -> false) g.(6);
    g.(7) <- Array.mapi (fun i b -> match i with 0|9 -> true | _ -> false) g.(7);
    g.(8) <- Array.mapi (fun i b -> match i with 0|9 -> true | _ -> false) g.(8);
    g.(9) <- Array.mapi (fun i b -> true) g.(9);
  )
  in
  let g = Array.make_matrix 10 10 false in
    init_grille g;
    g
;;

(* Programme optimal *)
let prog1 =
  {code = NodeOpSI ({code=NodeOpET ({code=NodeOpOU ({code=NodeVarN;haut=1},{code=NodeVarNE;haut=1});
                                     haut=1},
                                    {code=NodeOpNON {code=NodeVarE;haut=1};
                                     haut=1});
                     haut=1},
                    {code=NodeActEst;haut=1},
                    {code=NodeOpSI ({code=NodeOpET ({code=NodeOpOU ({code=NodeVarE;haut=1},
                                                                    {code=NodeVarSE;haut=1});
                                                     haut=1},
                                                    {code=NodeOpNON {code=NodeVarS;haut=1};
                                                     haut=1});
                                     haut=1},
                                    {code=NodeActSud;haut=1},
                                    {code=NodeOpSI ({code=NodeOpET ({code=NodeOpOU ({code=NodeVarS;haut=1},
                                                                                    {code=NodeVarSO;haut=1});
                                                                     haut=1},
                                                                    {code=NodeOpNON {code=NodeVarO;haut=1};
                                                                     haut=1});
                                                     haut=1},
                                                    {code=NodeActOuest;haut=1},
                                                    {code=NodeActNord;haut=1});
                                     haut=1});
                     haut=1});
   haut = 1}
;;

(* Programme non optimal *)
let prog2 =
  {code = NodeOpSI ({code=NodeOpET ({code=NodeOpOU ({code=NodeVarN;haut=1},{code=NodeVarNE;haut=1});
                                     haut=1},
                                    {code=NodeOpNON {code=NodeVarE;haut=1};
                                     haut=1});
                     haut=1},
                    {code=NodeActEst;haut=1},
                    {code=NodeOpSI ({code=NodeOpET ({code=NodeOpOU ({code=NodeVarE;haut=1},
                                                                    {code=NodeVarSE;haut=1});
                                                     haut=1},
                                                    {code=NodeOpNON {code=NodeVarE;haut=1};
                                                     haut=1});
                                     haut=1},
                                    {code=NodeActNord;haut=1},
                                    {code=NodeOpSI ({code=NodeOpET ({code=NodeOpOU ({code=NodeVarS;haut=1},
                                                                                    {code=NodeVarSO;haut=1});
                                                                     haut=1},
                                                                    {code=NodeOpNON {code=NodeVarO;haut=1};
                                                                     haut=1});
                                                     haut=1},
                                                    {code=NodeActOuest;haut=1},
                                                    {code=NodeActNord;haut=1});
                                     haut=1});
                     haut=1});
   haut = 1}
;;
