open Util;;
open Eval;;
open Genetique;;
open Exemples;;
open Typage;;

(* Calcul du score d'un prog *)
let test1 () = (* Teste tous les parcours possibles pour le prog 1 *)
  affiche prog1; 
  for i=1 to 8 do
    for j=1 to 8 do
      Printf.fprintf stdout "score(%d,%d) = %d\n" i j (eval_prog grille1 i j prog1);
    done;
  done;
;;

(* Lecture du fuchier de conf *)
let test2 () = 
  (* Ouverture du fichier de config *)
  let fic = open_in "configuration" in
  (* Lecture du fichier de config *)
  (* Lecture des paramtres numriques *)
  let nb_pgm = Scanf.sscanf (input_line fic) "nb de pgms: %d" (fun x -> x) in
  Printf.fprintf stdout "nb de pgms: %d\n" nb_pgm;
  let nb_essais = Scanf.sscanf (input_line fic) "nb d essais: %d" (fun x -> x) in
  Printf.fprintf stdout "nb_essais: %d\n" nb_essais;
  let nb_immort = Scanf.sscanf (input_line fic) "nb d immortels: %d" (fun x -> x) in
  Printf.fprintf stdout "nb_immort: %d\n" nb_immort;
  let nb_part = Scanf.sscanf (input_line fic) "nb de participants: %d" (fun x -> x) in
  Printf.fprintf stdout "nb_part: %d\n" nb_part;
  let prof = Scanf.sscanf (input_line fic) "profondeur max: %d" (fun x -> x) in
  Printf.fprintf stdout "prof: %d\n" prof;
  let type_pgm_init = Scanf.sscanf (input_line fic) "type pgm init: %d" (fun x -> x) in
  Printf.fprintf stdout "type_pgm_init: %d\n" type_pgm_init;
  let max_gen = Scanf.sscanf (input_line fic) "nb generations max: %d" (fun x -> x) in
  Printf.fprintf stdout "max_gen: %d\n" max_gen;
  (* Dimensions de la grille *)
  let larg = Scanf.sscanf (input_line fic) "largeur(x): %d" (fun x -> x) in
  let haut = Scanf.sscanf (input_line fic) "hauteur(y): %d" (fun x -> x) in
  let nb_adj = Scanf.sscanf (input_line fic) "nb cases adj: %d" (fun x -> x) in
  Printf.fprintf stdout "nb_adj: %d\n" nb_adj;
  (* La grille *)
  let grille = Array.make_matrix larg haut false in
  for j = 0 to (haut-1) do
    for i = 0 to (larg-1) do
      (*grille.(i).(j) <- (Scanf.fscanf fic "%d" (fun x -> match x with 0 -> false | _ -> true));*)
      grille.(i).(j) <- (Scanf.fscanf fic "%d" (function 0 -> false | _ -> true));
    done;
    ignore (input_line fic);
  done;
  for j = 0 to (haut-1) do
    for i = 0 to (larg-1) do
      Printf.fprintf stdout "%d " ((function true -> 1 | _ -> 0) grille.(i).(j));
    done;
    Printf.fprintf stdout "\n";
  done;
  Printf.fprintf stdout "\n";
;;

(* Score sur plusieurs essais d'un prog *)
let test3 () = 
  (* Ouverture du fichier de config *)
  let fic = open_in "configuration" in
  (* Lecture du fichier de config *)
  (* Lecture des paramtres numriques *)
  let nb_pgm = Scanf.sscanf (input_line fic) "nb de pgms: %d" (fun x -> x) in
  let nb_essais = Scanf.sscanf (input_line fic) "nb d essais: %d" (fun x -> x) in
  let nb_immort = Scanf.sscanf (input_line fic) "nb d immortels: %d" (fun x -> x) in
  let nb_part = Scanf.sscanf (input_line fic) "nb de participants: %d" (fun x -> x) in
  let prof = Scanf.sscanf (input_line fic) "profondeur max: %d" (fun x -> x) in
  let type_pgm_init = Scanf.sscanf (input_line fic) "type pgm init: %d" (fun x -> x) in
  let max_gen = Scanf.sscanf (input_line fic) "nb generations max: %d" (fun x -> x) in
  (* Dimensions de la grille *)
  let larg = Scanf.sscanf (input_line fic) "largeur(x): %d" (fun x -> x) in
  let haut = Scanf.sscanf (input_line fic) "hauteur(y): %d" (fun x -> x) in
  let nb_adj = Scanf.sscanf (input_line fic) "nb cases adj: %d" (fun x -> x) in
  (* La grille en elle-mme *)
  let grille = Array.make_matrix larg haut false in
  for j = 0 to (haut-1) do
    for i = 0 to (larg-1) do
      grille.(i).(j) <- (Scanf.fscanf fic "%d" (function 0 -> false | _ -> true));
    done;
    ignore (input_line fic);
  done;
  (* Initialisation du gnrateur de nombres alatoire *)
  Random.self_init ();
  Printf.fprintf stdout "score final 1 = %d\n" (score_prog grille larg haut nb_essais prog1);
  Printf.fprintf stdout "score final 2 = %d\n" (score_prog grille larg haut nb_essais prog2);
;;

(* Probas de la gnration init et quick_find *)
let test4 () = 
  let p1 = make_proba_1 5 in
  let p2 = make_proba_2 5 in
  for i = 0 to 4 do
    Printf.fprintf stdout "%d|" i;
    for j = 0 to 18 do
      Printf.fprintf stdout "%4d|" p1.(i).(j);
    done;
    Printf.fprintf stdout "\n";
  done;
  for i = 0 to 4 do
    Printf.fprintf stdout "%d|" i;
    for j = 0 to 18 do
      Printf.fprintf stdout "%4d|" p2.(i).(j);
    done;
    Printf.fprintf stdout "\n";
  done;
  for i = 1 to 10 do
    Printf.fprintf stdout "val=%d -> %d\n" (i*100) (quick_find (i*100) p2.(1));
  done;
;;

(* Pop init *)
let test5 () = 
  let pgms1 = init_gen 1000 5 1 in
  let pgms2 = init_gen 1000 5 2 in
  for i = 0 to 10 do
    Printf.fprintf stdout "-1----%d-----\n" i;
    affiche pgms1.(i);
  done;
  for i = 0 to 10 do
    Printf.fprintf stdout "-2----%d-----\n" i;
    affiche pgms2.(i);
  done;
;;

(* Les tournois (mettre le nombre de pgm ds le fichier de conf  10) *)
let test6 () =
  (* Ouverture du fichier de config *)
  let fic = open_in "configuration" in
  (* Lecture du fichier de config *)
  (* Lecture des paramtres numriques *)
  let nb_pgm = Scanf.sscanf (input_line fic) "nb de pgms: %d" (fun x -> x) in
  let nb_essais = Scanf.sscanf (input_line fic) "nb d essais: %d" (fun x -> x) in
  let nb_immort = Scanf.sscanf (input_line fic) "nb d immortels: %d" (fun x -> x) in
  let nb_part = Scanf.sscanf (input_line fic) "nb de participants: %d" (fun x -> x) in
  let prof = Scanf.sscanf (input_line fic) "profondeur max: %d" (fun x -> x) in
  let type_pgm_init = Scanf.sscanf (input_line fic) "type pgm init: %d" (fun x -> x) in
  let max_gen = Scanf.sscanf (input_line fic) "nb generations max: %d" (fun x -> x) in
  (* Dimensions de la grille *)
  let larg = Scanf.sscanf (input_line fic) "largeur(x): %d" (fun x -> x) in
  let haut = Scanf.sscanf (input_line fic) "hauteur(y): %d" (fun x -> x) in
  let nb_adj = Scanf.sscanf (input_line fic) "nb cases adj: %d" (fun x -> x) in
  (* La grille en elle-mme *)
  let grille = Array.make_matrix larg haut false in
  for j = 0 to (haut-1) do
    for i = 0 to (larg-1) do
      grille.(i).(j) <- (Scanf.fscanf fic "%d" (function 0 -> false | _ -> true));
    done;
    ignore (input_line fic);
  done;
  (* Initialisation du gnrateur de nombres alatoire *)
  Random.self_init ();
  (* 1ere gnration *)
  let pgms = init_gen nb_pgm prof type_pgm_init in
  let scores = Array.map (score_prog grille larg haut nb_essais) pgms in
  for i = 0 to 9 do
    Printf.fprintf stdout "------%d-----\n" i;
    affiche pgms.(i);
    Printf.fprintf stdout "score = %d\n" scores.(i);
  done;
  let best = tournoi nb_part scores in
  Printf.fprintf stdout "best = %d\n" best;
  affiche pgms.(best);
;;

(* Pour test7 *)
let affiche2 pgm = 
  let rec print_esp n =
    if n > 0 then (
      Printf.fprintf stdout " ";
      print_esp (n-1))
  in
  let rec aff_aux node nb_esp = 
    Printf.fprintf stdout "(";
    ( match node.code with
      Empty -> Printf.fprintf stdout "()\n"
    | NodeVarN -> Printf.fprintf stdout "n(%d)" node.haut
    | NodeVarNO -> Printf.fprintf stdout "no(%d)" node.haut
    | NodeVarNE -> Printf.fprintf stdout "ne(%d)" node.haut
    | NodeVarO -> Printf.fprintf stdout "o(%d)" node.haut
    | NodeVarE -> Printf.fprintf stdout "e(%d)" node.haut
    | NodeVarSO -> Printf.fprintf stdout "so(%d)" node.haut
    | NodeVarSE -> Printf.fprintf stdout "se(%d)" node.haut
    | NodeVarS -> Printf.fprintf stdout "s(%d)" node.haut
    | NodeActNord -> Printf.fprintf stdout "nord(%d)" node.haut
    | NodeActOuest -> Printf.fprintf stdout "ouest(%d)" node.haut
    | NodeActEst -> Printf.fprintf stdout "est(%d)" node.haut
    | NodeActSud -> Printf.fprintf stdout "sud(%d)" node.haut
    | NodeConst0 -> Printf.fprintf stdout "0(%d)" node.haut
    | NodeConst1 -> Printf.fprintf stdout "1(%d)" node.haut
    | NodeOpSI (fils1,fils2,fils3) -> 
        Printf.fprintf stdout "SI(%d) " node.haut;
        aff_aux fils1 (nb_esp + 7);
        Printf.fprintf stdout "\n";
        print_esp (nb_esp + 7);
        aff_aux fils2 (nb_esp + 7);
        Printf.fprintf stdout "\n";
        print_esp (nb_esp + 7);
        aff_aux fils3 (nb_esp + 7);
    | NodeOpOU (fils1,fils2) -> 
        Printf.fprintf stdout "OU(%d) " node.haut;
        aff_aux fils1 (nb_esp + 7);
        Printf.fprintf stdout "\n";
        print_esp (nb_esp + 7);
        aff_aux fils2 (nb_esp + 7);
    | NodeOpET (fils1,fils2) -> 
        Printf.fprintf stdout "ET(%d) " node.haut;
        aff_aux fils1 (nb_esp + 7);
        Printf.fprintf stdout "\n";
        print_esp (nb_esp + 7);
        aff_aux fils2 (nb_esp + 7);
    | NodeOpNON (fils1) -> 
        Printf.fprintf stdout "NON(%d) " node.haut;
        aff_aux fils1 (nb_esp + 8);
     );
    Printf.fprintf stdout ")"
  in
  aff_aux pgm 0;
  Printf.fprintf stdout "\n";
  flush stdout
;;

(* Recopie d'un programme et calcul de hauteur *)
let test7 () =
  let pgm1_cpy = copie_prog prog1 in
  Printf.fprintf stdout "Original\n";
  affiche prog1;
  Printf.fprintf stdout "Copie\n";
  affiche pgm1_cpy;
  Printf.fprintf stdout "haut = %d\n" (haut_prog pgm1_cpy);
  affiche2 pgm1_cpy;
;;

(* Sous programmes *)
let test8 () =
  (* Initialisation du gnrateur de nombres alatoire *)
  Random.self_init ();
  ignore (haut_prog prog1);
  let somme =ref 0 in
  let t1 =ref 0 in
  let t2 =ref 0 in
  let t3 =ref 0 in
  let t4 =ref 0 in
  let t5 =ref 0 in
  let t6 =ref 0 in
  for i = 1 to 1000 do
    match (sous_prog prog1).haut with
        1 -> 
          somme := !somme + 1;
          t1 := !t1 + 1;
      | 2 -> 
          somme := !somme + 2;
          t2 := !t2 + 1;
      | 3 -> 
          somme := !somme + 3;
          t3 := !t3 + 1;
      | 4 -> 
          somme := !somme + 4;
          t4 := !t4 + 1;
      | 5 -> 
          somme := !somme + 5;
          t5 := !t5 + 1;
      | 6 -> 
          somme := !somme + 6;
          t6 := !t6 + 1;
      | _ -> ();
  done;
  Printf.fprintf stdout "moy sur 1000 = %f\n" (float_of_int(!somme) /. 1000.); 
  Printf.fprintf stdout "t1 = %d | t2 = %d | t3 = %d | t4 = %d | t5 = %d | t6 = %d\n" !t1 !t2 !t3 !t4 !t5 !t6;
  somme := 0;
  t1 := 0;
  t2 := 0;
  t3 := 0;
  t4 := 0;
  t5 := 0;
  t6 := 0;
  for i = 1 to 1000 do
    match (sous_prog prog1).haut with
        1 -> 
          somme := !somme + 1;
          t1 := !t1 + 1;
      | 2 -> 
          somme := !somme + 2;
          t2 := !t2 + 1;
      | 3 -> 
          somme := !somme + 3;
          t3 := !t3 + 1;
      | 4 -> 
          somme := !somme + 4;
          t4 := !t4 + 1;
      | 5 -> 
          somme := !somme + 5;
          t5 := !t5 + 1;
      | 6 -> 
          somme := !somme + 6;
          t6 := !t6 + 1;
      | _ -> ();
  done;
  Printf.fprintf stdout "moy sur 1000 = %f\n" (float_of_int(!somme) /. 1000.); 
  Printf.fprintf stdout "t1 = %d | t2 = %d | t3 = %d | t4 = %d | t5 = %d | t6 = %d\n" !t1 !t2 !t3 !t4 !t5 !t6;
  affiche prog1;
  let ss_pgm1 = sous_prog prog1 in
  Printf.fprintf stdout "---1-----haut=%d\n" ss_pgm1.haut;
  affiche ss_pgm1;
  let ss_pgm2 = sous_prog prog1 in
  Printf.fprintf stdout "---2-----haut=%d\n" ss_pgm2.haut;
  affiche ss_pgm2;
  let ss_pgm3 = sous_prog prog1 in
  Printf.fprintf stdout "---3-----haut=%d\n" ss_pgm3.haut;
  affiche ss_pgm3;
  let ss_pgm4 = sous_prog prog1 in
  Printf.fprintf stdout "---4-----haut=%d\n" ss_pgm4.haut;
  affiche ss_pgm4;
  let ss_pgm5 = sous_prog prog1 in
  Printf.fprintf stdout "---5-----haut=%d\n" ss_pgm5.haut; 
  affiche ss_pgm5;
 ;;

(* Croisement *)
(*
let test9 () = 
  Random.self_init ();
  ignore (haut_prog prog1);
  affiche prog1;
  let ss_pgm = ref {code=Empty;haut=0} in
  for i = 1 to 5 do
    Printf.fprintf stdout "---%d-----\n" i;
    ss_pgm := copie_prog (sous_prog prog1); 
    affiche !ss_pgm; 
    affiche (croisement_aux prog1 !ss_pgm); 
  done; 
;;
*)

(* Mutations *)
let test10 () = 
  Random.self_init ();
  let p = 5 in
  let nb = 5000 in
  let c =ref nb in
  for i = 1 to nb do
    try (
      (*cp_mut_prog prog1 p;*) (* a decommenter av lancer test (commentaires pour eviter warning) *)
      c := !c - 1;
    )
    with  _ -> ();
  done;
  Printf.fprintf stdout "Sur %d: %d prog modifies\n" nb !c;
;;

(* Recherche d'un programme optimal sans mutation mais avec rduction des programmes *)
let main_sans_mutation () = 
  (* Ouverture du fichier de config *)
  let fic = open_in "configuration" in
  (* Lecture du fichier de config *)
  (* Lecture des paramtres numriques *)
  let nb_pgm = Scanf.sscanf (input_line fic) "nb de pgms: %d" (fun x -> x) in
  let nb_essais = Scanf.sscanf (input_line fic) "nb d essais: %d" (fun x -> x) in
  let nb_immort = Scanf.sscanf (input_line fic) "nb d immortels: %d" (fun x -> x) in
  let nb_part = Scanf.sscanf (input_line fic) "nb de participants: %d" (fun x -> x) in
  let haut_init = Scanf.sscanf (input_line fic) "hauteur init max: %d" (fun x -> x) in
  let haut_simpl = Scanf.sscanf (input_line fic) "hauteur max: %d" (fun x -> x) in
  let type_pgm_init = Scanf.sscanf (input_line fic) "type pgm init: %d" (fun x -> x) in
  let max_gen = Scanf.sscanf (input_line fic) "nb generations max: %d" (fun x -> x) in
  (* Dimensions de la grille *)
  let larg = Scanf.sscanf (input_line fic) "largeur(x): %d" (fun x -> x) in
  let haut = Scanf.sscanf (input_line fic) "hauteur(y): %d" (fun x -> x) in
  let nb_adj = Scanf.sscanf (input_line fic) "nb cases adj: %d" (fun x -> x) in
  (* La grille en elle-mme *)
  let grille = Array.make_matrix larg haut false in
  for j = 0 to (haut-1) do
    for i = 0 to (larg-1) do
      grille.(i).(j) <- (Scanf.fscanf fic "%d" (function 0 -> false | _ -> true));
    done;
    ignore (input_line fic);
  done;
  (* Fermeture du fichier de configuration *)
  close_in fic;
  (* Initialisation du gnrateur de nombres alatoire *)
  Random.self_init ();
  (* Affichage du programme optimal *)
  let aff_optimal scores i pgm =
    if scores.(i) = nb_adj * nb_essais then
      begin
        (* Affichage complet *)
        Printf.fprintf stdout "-------------------\n";
        affiche pgm;
        (* Vrification que le prog est bien optimal pour toutes les positions init *)
        Printf.fprintf stdout "Verification du programme optimal\n";
        let erreur = ref false in
        for i=1 to haut-2 do
          for j=1 to larg-2 do
            if grille.(i).(j) <> true then
              if (eval_prog grille i j pgm) <> nb_adj then (
                Printf.fprintf stdout "Parcours non complet a la position (%d,%d)\n" i j;
                erreur := true;
              )
          done;
        done;
        if !erreur then (
          Printf.fprintf stdout "Programme non optimal\n";
        )
        else
          Printf.fprintf stdout "OK\n";
        (* Affichage simplifi *)
        let pgm_simpl = simpl_prog pgm in
        erreur := false; (* On vrifie que la simplification est correcte *)
        for i=1 to haut-2 do
          for j=1 to larg-2 do
            if grille.(i).(j) <> true then
              if (eval_prog grille i j pgm_simpl) <> nb_adj then (
                erreur := true;
              )
          done;
        done;
        if !erreur then (
          Printf.fprintf stdout "Version simplifiee incorrecte...\n";
          affiche pgm_simpl;
        )
        else (
          Printf.fprintf stdout "Version simplifiee\n";
          affiche pgm_simpl;
        )
      end
  in
  (* Pour les statistiques *)
  let stat_tab tab =
    (* Calcul le max et la somme du tableau *)
    let f (maxi,som) x =
      if maxi < x then
        (x,som+x)
      else
        (maxi,som+x)
    in
    let c = Array.fold_left f (0,0) tab in
    (* Retourne le max et la moy *)
    (fst c,float_of_int((snd c)) /. float_of_int((Array.length tab)))
  in
  (* 1ere gnration *)
  let pgms = ref (init_gen nb_pgm haut_init type_pgm_init) in
  let scores = ref (Array.map (score_prog grille larg haut nb_essais) !pgms) in
  let hauteurs = ref (Array.map haut_prog !pgms) in
  (* Gnration suivantes *)
  let i = ref 0 in
  let find = ref 0 in
  let compt = ref 0 in
  let scores_stat = ref (0,0.) in
  let haut_stat = ref (0,0.) in
  while !i < max_gen do
    scores_stat := stat_tab !scores;
    haut_stat := stat_tab !hauteurs;
    Printf.fprintf stdout "Generation %2d : score max=%3d moy=%3.1f / haut max=%2d moy=%2.1f\n"
      !i (fst !scores_stat) (snd !scores_stat) (fst !haut_stat) (snd !haut_stat);
    flush stdout;
    if (fst !scores_stat) = nb_adj * nb_essais then (
      Printf.fprintf stdout "Programme(s) optimal(s) trouve(s):\n";
      Array.iteri (aff_optimal !scores) !pgms;
      find := !i;
      i := max_gen + 1;
    )
    else (
      if (fst !haut_stat) >= (haut_simpl+(!compt)) then (* Les pgm sont trop longs -> rduction *) (
        Printf.fprintf stdout "Programmes trop longs -> reduction \n";
        pgms := Array.map simpl_prog !pgms;
        compt := !compt + (haut_simpl / 4);
        Gc.compact ();
      );
      pgms := pop_suivante !pgms nb_immort grille nb_essais  nb_part;
      scores := Array.map (score_prog grille larg haut nb_essais) !pgms;
      hauteurs := Array.map haut_prog !pgms;
      i := !i + 1;
    )
  done;
  if !i = max_gen then (* Aucun programme optimal n'a t trouv *)
    raise  AucunPgmTrouve
  else
    !find
;;

(* Statistiques sur le main_sans_mutation *)
let stat_sans_mutation () = 
  let nb = 30 in
  let f i =
    Gc.compact ();
    Printf.fprintf stdout "----------====test %d====---------\n" i;
    try
      main_sans_mutation ()
    with
        AucunPgmTrouve -> 0
  in
  let resume = Array.init nb f in
  let som = ref 0 in
  let sigma = ref 0 in
  for i = 0 to nb-1 do
    Printf.fprintf stdout "%2d | %2d\n" i  resume.(i);
    if resume.(i) > 0 then (
      som := !som + 1;
      sigma := !sigma + resume.(i);
    )
  done;
  Printf.fprintf stdout "Generation moy : %f\n" ((float_of_int !sigma) /. (float_of_int !som));
  Printf.fprintf stdout "%d pgm trouves sur %d essais" !som nb;
;;

let main_avec_mutation () =
  (* Ouverture du fichier de config *)
  let fic = open_in "configuration" in
  (* Lecture du fichier de config *)
  (* Lecture des paramtres numriques *)
  let nb_pgm = Scanf.sscanf (input_line fic) "nb de pgms: %d" (fun x -> x) in
  let nb_essais = Scanf.sscanf (input_line fic) "nb d essais: %d" (fun x -> x) in
  let nb_immort = Scanf.sscanf (input_line fic) "nb d immortels: %d" (fun x -> x) in
  let nb_part = Scanf.sscanf (input_line fic) "nb de participants: %d" (fun x -> x) in
  let haut_init = Scanf.sscanf (input_line fic) "hauteur init max: %d" (fun x -> x) in
  let haut_simpl = Scanf.sscanf (input_line fic) "hauteur max: %d" (fun x -> x) in
  let type_pgm_init = Scanf.sscanf (input_line fic) "type pgm init: %d" (fun x -> x) in
  let max_gen = Scanf.sscanf (input_line fic) "nb generations max: %d" (fun x -> x) in
  (* Dimensions de la grille *)
  let larg = Scanf.sscanf (input_line fic) "largeur(x): %d" (fun x -> x) in
  let haut = Scanf.sscanf (input_line fic) "hauteur(y): %d" (fun x -> x) in
  let nb_adj = Scanf.sscanf (input_line fic) "nb cases adj: %d" (fun x -> x) in
  (* La grille en elle-mme *)
  let grille = Array.make_matrix larg haut false in
  for j = 0 to (haut-1) do
    for i = 0 to (larg-1) do
      grille.(i).(j) <- (Scanf.fscanf fic "%d" (function 0 -> false | _ -> true));
    done;
    ignore (input_line fic);
  done;
  (* Fermeture du fichier de configuration *)
  close_in fic;
  (* Initialisation du gnrateur de nombres alatoire *)
  Random.self_init ();
  (* Affichage du programme optimal *)
  let aff_optimal scores i pgm =
    if scores.(i) = nb_adj * nb_essais then
      begin
        (* Affichage complet *)
        Printf.fprintf stdout "-------------------\n";
        affiche pgm;
        (* Vrification que le prog est bien optimal pour toutes les positions init *)
        Printf.fprintf stdout "Verification du programme optimal\n";
        let erreur = ref false in
        for i=1 to haut-2 do
          for j=1 to larg-2 do
            if grille.(i).(j) <> true then
              if (eval_prog grille i j pgm) <> nb_adj then (
                Printf.fprintf stdout "Parcours non complet a la position (%d,%d)\n" i j;
                erreur := true;
              )
          done;
        done;
        if !erreur then (
          Printf.fprintf stdout "Programme non optimal\n";
        )
        else
          Printf.fprintf stdout "OK\n";
        (* Affichage simplifi *)
        let pgm_simpl = simpl_prog pgm in
        erreur := false; (* On vrifie que la simplification est correcte *)
        for i=1 to haut-2 do
          for j=1 to larg-2 do
            if grille.(i).(j) <> true then
              if (eval_prog grille i j pgm_simpl) <> nb_adj then (
                erreur := true;
              )
          done;
        done;
        if !erreur then (
          Printf.fprintf stdout "Version simplifiee incorrecte...\n";
          affiche pgm_simpl;
        )
        else (
          Printf.fprintf stdout "Version simplifiee\n";
          affiche pgm_simpl;
        )
      end
  in
  (* Pour les statistiques *)
  let stat_tab tab =
    (* Calcul le max et la somme du tableau *)
    let f (maxi,som) x = (max maxi x , som+x) in
    let c = Array.fold_left f (0,0) tab in
    (* Retourne le max et la moy *)
    (fst c , float_of_int((snd c)) /. float_of_int((Array.length tab)))
  in
  (* Pour calculer la probabilit de mutation des programme *)
  let proba_mutation last_score_moy  cur_score_moy =
    let proba_mut_min = 20 in
    match abs(last_score_moy - cur_score_moy) with
        0 -> proba_mut_min + 60
      | 1 -> proba_mut_min + 15
      | 2 -> proba_mut_min + 5
      | _ -> proba_mut_min
  in
  (* 1ere gnration *)
  let pgms = ref (init_gen nb_pgm haut_init type_pgm_init) in
  let scores = ref (Array.map (score_prog grille larg haut nb_essais) !pgms) in
  let hauteurs = ref (Array.map haut_prog !pgms) in
  (* Gnration suivantes *)
  let i = ref 0 in
  let last_score_moy = ref 0 in
  let find = ref 0 in
  let compt = ref 0 in
  let scores_stat = ref (0,0.) in
  let haut_stat = ref (0,0.) in
  while !i < max_gen do
    scores_stat := stat_tab !scores;
    haut_stat := stat_tab !hauteurs;
    Printf.fprintf stdout "Generation %2d : score max=%3d moy=%3.1f / haut max=%2d moy=%2.1f\n"
      !i (fst !scores_stat) (snd !scores_stat) (fst !haut_stat) (snd !haut_stat);
    flush stdout;
    if (fst !scores_stat) = nb_adj * nb_essais then (
      Printf.fprintf stdout "Programme(s) optimal(s) trouve(s):\n";
      Array.iteri (aff_optimal !scores) !pgms;
      find := !i;
      i := max_gen + 1;
    )
    else (* Passage  la gnration suivante *) (
      if (fst !haut_stat) >= (haut_simpl+(!compt)) then (* Les pgm sont trop longs -> rduction *) (
        Printf.fprintf stdout "Programmes trop longs -> reduction \n";
        pgms := Array.map simpl_prog !pgms;
        compt := !compt + (haut_simpl / 4);
        Gc.compact (); (* Pour viter des problmes de saturation de mmoire *)
      );
      pgms := pop_mut_suivante !pgms nb_immort grille nb_essais  nb_part 
        (proba_mutation !last_score_moy  (int_of_float (snd !scores_stat)));
      scores := Array.map (score_prog grille larg haut nb_essais) !pgms;
      hauteurs := Array.map haut_prog !pgms;
      i := !i + 1;
      last_score_moy := int_of_float (snd !scores_stat);
)
  done;
  if !i = max_gen then (* Aucun programme optimal n'a t trouv *)
    raise  AucunPgmTrouve
  else
    !find
;;

(* Statistiques sur le main_avec_mutation *)
let stat_avec_mutation () = 
  let nb = 30 in
  let f i =
    Gc.compact ();
    Printf.fprintf stdout "\n----------====test %d====---------\n" i;
    try
      main_avec_mutation ()
    with
        AucunPgmTrouve -> 0
  in
  let resume = Array.init nb f in
  let som = ref 0 in
  let sigma = ref 0 in
  for i = 0 to nb-1 do
    Printf.fprintf stdout "%2d | %2d\n" i  resume.(i);
    if resume.(i) > 0 then (
      som := !som + 1;
      sigma := !sigma + resume.(i);
    )
  done;
  Printf.fprintf stdout "Generation moy : %f\n" ((float_of_int !sigma) /. (float_of_int !som));
  Printf.fprintf stdout "%d pgm trouves sur %d essais" !som nb;
;;

let _ = main_avec_mutation () ;;

