(***************************************************************************
 * Arbre reprsentant un programme pour le robot
 ***************************************************************************)

type arbre_prog = {code: node;
                   mutable haut: int}

and node = 
      (* Arbre vide *)
    Empty
      (* Les noeuds reprsentant des oprateurs *)
  | NodeOpSI of arbre_prog * arbre_prog * arbre_prog
  | NodeOpOU of arbre_prog * arbre_prog
  | NodeOpET of arbre_prog * arbre_prog
  | NodeOpNON of arbre_prog
      (* Les noeuds reprsentant des actions *)
  | NodeActNord
  | NodeActOuest
  | NodeActEst
  | NodeActSud
      (* Les noeuds reprsentant des variables *)
  | NodeVarN
  | NodeVarNO
  | NodeVarNE
  | NodeVarO
  | NodeVarE
  | NodeVarSO
  | NodeVarSE
  | NodeVarS
      (* Les noeuds reprsentant des constantes *)
  | NodeConst0
  | NodeConst1
;;


(***************************************************************************
 * Valeur d'une valuation de programme
 ***************************************************************************)

type eval_prog = EvalBoolVrai
               | EvalBoolFaux
               | EvalActionNord
               | EvalActionOuest
               | EvalActionEst
               | EvalActionSud
               | EvalActionStop
;;


(***************************************************************************
 * Les exceptions
 ***************************************************************************)

exception EltProgInconnu of int;;
exception ExisteDejaDansListe;;
exception ValeurHorsTab of int * int;;
exception PgmVide;;
exception AucunPgmTrouve;;
